#include <tap.h>
#include "exTap.h"

//----------------------------------------------------------------------------
void patch_hook();
int exTAP_ApplyHook(type_hook *hook);
int exTAP_RemoveHook(int id);

extern dword *patch_hook_main;
//----------------------------------------------------------------------------
void patch_hook()
{
    //set the address of tap_ident, tap_table in hook_main()
    *(word *)((dword)&patch_hook_main+2) = ((dword)fw_tap_ident >> 16) & 0xffff;
    *(word *)((dword)&patch_hook_main+6) = ((dword)fw_tap_ident >> 00) & 0xffff;
    *(word *)((dword)&patch_hook_main+10) = ((dword)fw_tap_table >> 16) & 0xffff;
    *(word *)((dword)&patch_hook_main+14) = ((dword)fw_tap_table >> 00) & 0xffff;
}

static __inline__ int hook_prefix()
{
    //save some registers
    __asm__ __volatile__ (
    ".set noat\n"
    "addiu   $29,$29,0xff70\n"              //addiu   $sp,$sp,-0x90
    "sw      $0, 0x0010($29)\n"             //sw      $0, 0x0010($sp)         save 0
    "sw      $1, 0x0014($29)\n"             //sw      $at,0x0014($sp)         save at
    "sw      $2, 0x0018($29)\n"             //sw      $v0,0x0018($sp)         save v0
    "sw      $3, 0x001c($29)\n"             //sw      $v1,0x001c($sp)         save v1
    "sw      $4, 0x0020($29)\n"             //sw      $a0,0x0020($sp)         save a0
    "sw      $5, 0x0024($29)\n"             //sw      $a1,0x0024($sp)         save a1
    "sw      $6, 0x0028($29)\n"             //sw      $a2,0x0028($sp)         save a2
    "sw      $7, 0x002c($29)\n"             //sw      $a3,0x002c($sp)         save a3

    "sw      $8, 0x0030($29)\n"             //sw      $t0,0x0030($sp)         save t0
    "sw      $9, 0x0034($29)\n"             //sw      $t1,0x0034($sp)         save t1
    "sw      $10,0x0038($29)\n"             //sw      $t2,0x0038($sp)         save t2
    "sw      $11,0x003c($29)\n"             //sw      $t3,0x003c($sp)         save t3
    "sw      $12,0x0040($29)\n"             //sw      $t4,0x0040($sp)         save t4
    "sw      $13,0x0044($29)\n"             //sw      $t5,0x0044($sp)         save t5
    "sw      $14,0x0048($29)\n"             //sw      $t6,0x0048($sp)         save t6
    "sw      $15,0x004c($29)\n"             //sw      $t7,0x004c($sp)         save t7

    "sw      $16,0x0050($29)\n"             //sw      $s0,0x0050($sp)         save s0
    "sw      $17,0x0054($29)\n"             //sw      $s1,0x0054($sp)         save s1
    "sw      $18,0x0058($29)\n"             //sw      $s2,0x0058($sp)         save s2
    "sw      $19,0x005c($29)\n"             //sw      $s3,0x005c($sp)         save s3
    "sw      $20,0x0060($29)\n"             //sw      $s4,0x0060($sp)         save s4
    "sw      $21,0x0064($29)\n"             //sw      $s5,0x0064($sp)         save s5
    "sw      $22,0x0068($29)\n"             //sw      $s6,0x0068($sp)         save s6
    "sw      $23,0x006c($29)\n"             //sw      $s7,0x006c($sp)         save s7

    "sw      $24,0x0070($29)\n"             //sw      $t8,0x0070($sp)         save t8
    "sw      $25,0x0074($29)\n"             //sw      $t9,0x0074($sp)         save t9
    "sw      $26,0x0078($29)\n"             //sw      $k9,0x0078($sp)         save k0
    "sw      $27,0x007c($29)\n"             //sw      $k9,0x007c($sp)         save k1
    "sw      $28,0x0080($29)\n"             //sw      $gp,0x0080($sp)         save gp
    "sw      $29,0x0084($29)\n"             //sw      $sp,0x0084($sp)         save sp
    "sw      $30,0x0088($29)\n"             //sw      $s8,0x0088($sp)         save s8
    "sw      $31,0x008c($29)\n"             //sw      $ra,0x008c($sp)         save ra
    :
    :
    );
}


static __inline__ hook_wrapper()
{
   __asm__ __volatile__ (
    ".set noat\n"
    "hook_main:\n"

    "move  $20, $0              \n"     //    move    $s4, $0                //tap_ident = 0

    "patch_hook_main:           \n"     //    a label so we can find this location to patch it
    "li    $21, 0x80177160      \n"     //    li      $s5, FW_TAP_IDENT_1288         !!! firmware specific,  patch this location later !!!
    "li    $22, 0x80176f60      \n"     //    li      $s6, FW_TAP_TABLE_1288         !!! firmware specific,  patch this location later !!!

    "lw    $23, 0($21)          \n"     //    lw      $s7, 0($s5)            //save  initial tap_ident

    "next_tap:                  \n"
    "lw    $19, 0x10($22)       \n"     //    lw      $s3, 0x10($s6)         //tap_entry - 0 if tap not present
    "beqz  $19, tap_not_present \n"     //    beqz    $s3, tap_not_present
    "sw    $20, 0($21)          \n"     //    sw      $s4, 0($s5)            //set current tap_ident
    "lw    $16, 0x1c($19)       \n"     //    lw      $s0, 0x1c($s3)         //event_handler

    "lw    $19, 4($22)          \n"     //    lw      $s3, 4($s6)            //tap gp
    "move  $28, $19             \n"     //    move    $gp, $s3               //set gp

    "li    $4,  0xf100          \n"     //    li      $a0, EVT_HOOK          //event = EVT_HOOK (0xf100)
    "lw    $5,  0x0014($29)     \n"     //    lw      $a1,0x0014($sp)        //param1 = hook id (originally in $at)
    "addiu $6,  $29, 0x10       \n"     //    addiu   $a2, $sp, 0x10         //param2 = pointer to saved registers
    "jalr  $16                  \n"     //    jalr    $s0                    //ret = TAP_EventHandler(event, param1, param2)

    "lw    $19, 0($22)          \n"     //    lw      $s3, 0($s6)            //get firmware gp
    "move  $28, $19             \n"     //    move    $gp, $s3               //restore firmware gp

    "beqz  $2, taps_done0       \n"     //    beqz    $v0, taps_done0        //bail out if v0 == 0, to stop hook from being passed to more taps
    "bltz  $2, taps_doneNEG     \n"     //    bltz    $v0, taps_doneNEG      //bail out if v0 < 0, to force the hook to exit with an 'rts'

    "tap_not_present:           \n"
    "addiu $22, 0x20            \n"     //    addiu   $s6, 0x20              //next tap
    "addiu $20, 1               \n"     //    addiu   $s4, 1                 //next tap_ident
    "sltiu $1, $20, 0x10        \n"     //    sltiu   $at, $s4, 0x10         //got to 16 yet?
    "bnez  $1, next_tap         \n"     //    bnez    $at, next_tap          //go round again

    "taps_done0:                \n"
    "lw    $1, 0x0014($29)      \n"     //    lw      $at,0x0014($sp)        //hook id (originally in $at)
    "srl   $1, $1, 4            \n"     //    srl     $at, $at, 4            //ignore tap_ident offset
    "sll   $1, $1, 1            \n"     //    sll     $at, $at, 1            //hook id * 2
    "sw    $1, 0x0014($29)      \n"     //    sw      $at,0x0014($sp)        //save modified hook id
    "b     taps_done            \n"     //    b       taps_done              //continue

    "taps_doneNEG:              \n"
    "lw    $1, 0x0014($29)      \n"     //    lw      $at,0x0014($sp)        //hook id (originally in $at)
    "srl   $1, $1, 4            \n"     //    srl     $at, $at, 4            //ignore tap_ident offset
    "sll   $1, $1, 1            \n"     //    sll     $at, $at, 1            //hook id * 2
    "addiu $1, $1, 0x01         \n"     //    addiu   $at, $at, 0x01         //add 1 if rts
    "sw    $1, 0x0014($29)      \n"     //    sw      $at,0x0014($sp)        //save modified hook id

    "taps_done:                 \n"
    "sw    $23, 0($21)          \n"     //    sw      $s7, 0($s5)            //restore initial tap_ident
    :
    :
    );
}

static __inline__ int hook_postfix()
{
    //restore the registers
    __asm__ __volatile__ (
    ".set noat\n"
    "lw      $31,0x008c($29)\n"             //lw      $ra,0x008c($sp)         restore ra
    "lw      $30,0x0088($29)\n"             //lw      $s8,0x0088($sp)         restore s8
//  "lw      $29,0x0084($29)\n"             //lw      $sp,0x0084($sp)         restore sp
    "lw      $28,0x0080($29)\n"             //lw      $gp,0x0080($sp)         restore gp
    "lw      $27,0x007c($29)\n"             //lw      $k1,0x007c($sp)         restore k1
    "lw      $26,0x0078($29)\n"             //lw      $k0,0x0078($sp)         restore k0
    "lw      $25,0x0074($29)\n"             //lw      $t9,0x0074($sp)         restore t9
    "lw      $24,0x0070($29)\n"             //lw      $t8,0x0070($sp)         restore t8

    "lw      $23,0x006c($29)\n"             //lw      $s7,0x006c($sp)         restore s7
    "lw      $22,0x0068($29)\n"             //lw      $s6,0x0068($sp)         restore s6
    "lw      $21,0x0064($29)\n"             //lw      $s5,0x0064($sp)         restore s5
    "lw      $20,0x0060($29)\n"             //lw      $s4,0x0060($sp)         restore s4
    "lw      $19,0x005c($29)\n"             //lw      $s3,0x005c($sp)         restore s3
    "lw      $18,0x0058($29)\n"             //lw      $s2,0x0058($sp)         restore s2
    "lw      $17,0x0054($29)\n"             //lw      $s1,0x0054($sp)         restore s1
    "lw      $16,0x0050($29)\n"             //lw      $s0,0x0050($sp)         restore s0

    "lw      $15,0x004c($29)\n"             //lw      $s7,0x004c($sp)         restore t7
    "lw      $14,0x0048($29)\n"             //lw      $s6,0x0048($sp)         restore t6
    "lw      $13,0x0044($29)\n"             //lw      $s5,0x0044($sp)         restore t5
    "lw      $12,0x0040($29)\n"             //lw      $s4,0x0040($sp)         restore t4
    "lw      $11,0x003c($29)\n"             //lw      $s3,0x003c($sp)         restore t3
    "lw      $10,0x0038($29)\n"             //lw      $s2,0x0038($sp)         restore t2
    "lw      $9, 0x0034($29)\n"             //lw      $s1,0x0034($sp)         restore t1
    "lw      $8, 0x0030($29)\n"             //lw      $s0,0x0030($sp)         restore t0

    "lw      $7, 0x002c($29)\n"             //lw      $a3,0x002c($sp)         restore a3
    "lw      $6, 0x0028($29)\n"             //lw      $a2,0x0028($sp)         restore a2
    "lw      $5, 0x0024($29)\n"             //lw      $a1,0x0024($sp)         restore a1
    "lw      $4, 0x0020($29)\n"             //lw      $a0,0x0020($sp)         restore a0
    "lw      $3, 0x001c($29)\n"             //lw      $v1,0x001c($sp)         restore v1
    "lw      $2, 0x0018($29)\n"             //lw      $v0,0x0018($sp)         restore v0
    "lw      $1, 0x0014($29)\n"             //lw      $at,0x0014($sp)         restore at
//  "lw      $0, 0x0010($29)\n"             //lw      $0, 0x0010($sp)         restore 0
    "addiu   $29,$29,0x0090\n"              //addiu   $sp,$sp,0x90
    "hook_postfix2:\n"
    :
    :
    );
}

__inline__ int hook_exit()
{
//    ";  hook_postfix2:\n"
    __asm__ __volatile__ (
    ".set noat\n"

    //a bit crude ...
    "addiu $1, -2               \n"     //    addiu   $at, -2               //0 is not used to allow event to return 0
    "beqz  $1, hook_exit1       \n"     //    beqz    $at, hook_exit1
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit1       \n"     //    beqz    $at, hook_quit1
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit2       \n"     //    beqz    $at, hook_exit2
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit2       \n"     //    beqz    $at, hook_quit2
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit3       \n"     //    beqz    $at, hook_exit3
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit3       \n"     //    beqz    $at, hook_quit3
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit4       \n"     //    beqz    $at, hook_exit4
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit4       \n"     //    beqz    $at, hook_quit4
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit5       \n"     //    beqz    $at, hook_exit5
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit5       \n"     //    beqz    $at, hook_quit5
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit6       \n"     //    beqz    $at, hook_exit6
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit6       \n"     //    beqz    $at, hook_quit6
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit7       \n"     //    beqz    $at, hook_exit7
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit7       \n"     //    beqz    $at, hook_quit7
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit8       \n"     //    beqz    $at, hook_exit8
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit8       \n"     //    beqz    $at, hook_quit8
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit9       \n"     //    beqz    $at, hook_exit9
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit9       \n"     //    beqz    $at, hook_quit9
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit10      \n"     //    beqz    $at, hook_exit10
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit10      \n"     //    beqz    $at, hook_quit10
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit11      \n"     //    beqz    $at, hook_exit11
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit11      \n"     //    beqz    $at, hook_quit11
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit12      \n"     //    beqz    $at, hook_exit12
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit12      \n"     //    beqz    $at, hook_quit12
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit13      \n"     //    beqz    $at, hook_exit13
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit13      \n"     //    beqz    $at, hook_quit13
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit14      \n"     //    beqz    $at, hook_exit14
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit14      \n"     //    beqz    $at, hook_quit14
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit15      \n"     //    beqz    $at, hook_exit15
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit15      \n"     //    beqz    $at, hook_quit15
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_exit16      \n"     //    beqz    $at, hook_exit16
    "addiu $1, -1               \n"     //    addiu   $at, -1
    "beqz  $1, hook_quit16      \n"     //    beqz    $at, hook_quit16
    //broken ...
    "j     hook_quit16          \n"     //    j       hook_quit16
    );
}


extern void *hook_entry_generic;

//
//generic - needs patching with fw_tap_dent, fw_tap_table
//
static int hook()
{
    //cannot use anything that relies on $gp here ...
    //i.e. constants only, no variables

    __asm__ __volatile__ ("hook_entry_generic:\n");
    hook_prefix();      //save the original resgiters
    hook_wrapper();
    hook_postfix();     //restores the original registers
    hook_exit();
}


//this gets patched with the initially overwritten firmware code (up to 4 words)
//and the jump back into the firmware
int hook_exit1()
{
    __asm__ __volatile__ (
    "nop\n"                             //  first line of pFunc
    "nop\n"                             //  second line of pFunc
    "nop\n"                             //  j  firmware+8
    "nop\n"
    "nop\n"                             //this gets optimised after the rts ...
    :
    : );
}
int hook_exit2() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
int hook_exit3() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
int hook_exit4() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
int hook_exit5() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
int hook_exit6() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
int hook_exit7() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
int hook_exit8() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
int hook_exit9() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
int hook_exit10() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
int hook_exit11() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
int hook_exit12() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
int hook_exit13() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
int hook_exit14() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
int hook_exit15() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
int hook_exit16() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }

static int hook_quit1()
{
    __asm__ __volatile__ (
    "nop\n"                             //  first line of pFunc
    "nop\n"                             //  second line of pFunc
    "nop\n"                             //  j  $ra  (don't do it here, because gcc reoptimises for delay slots
    "nop\n"
    "nop\n"                             //this gets optimised after the rts ...
    :
    : );
}
static int hook_quit2() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit3() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit4() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit5() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit6() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit7() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit8() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit9() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit10() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit11() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit12() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit13() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit14() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit15() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }
static int hook_quit16() { __asm__ __volatile__ ("nop\nnop\nnop\nnop\nnop\n"); }

//----------------------------------------------------------------------------
typedef struct  {
    type_hook hook;
    dword exit;                 //hook exit address
    dword quit;                 //hook quit address
    byte  to[0x100];            //code patched to firmware
}type_hook_list;

type_hook_list hook_list[1+MAX_HOOKS];

//return -ve = error
//return +ve = hook_handle
int exTAP_ApplyHook(type_hook *hook)
{
    int i,j;
    int ret;
    int match;
    int id;
    dword *hook_entry;

    hook_entry = (dword *)&hook_entry_generic;

    //search though the list looking for a sysid/version match
    match = 0;
    j = 0;
    while (hook[j].sysid) {
        //check firmware version
        if ((hook[j].sysid == fw_sysid) && (hook[j].revision == _appl_version)) {
            match = 1;
            break;
        }
        j++;
    }
    if (!match) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
        TAP_Print("\n");
#endif
        return EXTAPERR_BAD_FIRMWARE;
    }



    if ((hook[j].enable) == 0) {
        //ignore; not enabled
        return EXTAPERR_OTHER;
    }

    //match against an existing
    for (i=1; i<=MAX_HOOKS; i++) {
        if (hook_list[i].hook.enable) {
            if (hook[j].addr == hook_list[i].hook.addr) {
                if (hook[j].length == hook_list[i].hook.length) {
#ifdef exTAPdebug
                    TAP_Print("\n%s(), hook already exists", __func__);
#endif
                    return EXTAPERR_ALREADY_PATCHED;
                }
            }
        }
    }

    //find a spare slot
    id = -1;
    for (i=1; i<=MAX_HOOKS; i++) {
        if (hook_list[i].hook.enable == 0) {
            id = i;
            break;
        }
    }
    if (id < 0) {
#ifdef exTAPdebug
        TAP_Print("\%s(), no more free hooks", __func__);
#endif
        return EXTAPERR_OTHER;
    }

    //save the hook details
    hook_list[id].hook.addr   = hook[j].addr;
    hook_list[id].hook.length = hook[j].length;
    memcpy(hook_list[id].hook.from, hook[j].from, hook[j].length);

//!!!this code produces 9x Warning: Macro used $at after ".set noat"
//seems to be bogus ...
    switch (id) {
        case 1:
            hook_list[id].exit = (dword)hook_exit1;
            hook_list[id].quit = (dword)hook_quit1;
            break;
        case 2:
            hook_list[id].exit = (dword)hook_exit2;
            hook_list[id].quit = (dword)hook_quit2;
            break;
        case 3:
            hook_list[id].exit = (dword)hook_exit3;
            hook_list[id].quit = (dword)hook_quit3;
            break;
        case 4:
            hook_list[id].exit = (dword)hook_exit4;
            hook_list[id].quit = (dword)hook_quit4;
            break;
        case 5:
            hook_list[id].exit = (dword)hook_exit5;
            hook_list[id].quit = (dword)hook_quit5;
            break;
        case 6:
            hook_list[id].exit = (dword)hook_exit6;
            hook_list[id].quit = (dword)hook_quit6;
            break;
        case 7:
            hook_list[id].exit = (dword)hook_exit7;
            hook_list[id].quit = (dword)hook_quit7;
            break;
        case 8:
            hook_list[id].exit = (dword)hook_exit8;
            hook_list[id].quit = (dword)hook_quit8;
            break;
        case 9:
            hook_list[id].exit = (dword)hook_exit9;
            hook_list[id].quit = (dword)hook_quit9;
            break;
        case 10:
            hook_list[id].exit = (dword)hook_exit10;
            hook_list[id].quit = (dword)hook_quit10;
            break;
        case 11:
            hook_list[id].exit = (dword)hook_exit11;
            hook_list[id].quit = (dword)hook_quit11;
            break;
        case 12:
            hook_list[id].exit = (dword)hook_exit12;
            hook_list[id].quit = (dword)hook_quit12;
            break;
        case 13:
            hook_list[id].exit = (dword)hook_exit13;
            hook_list[id].quit = (dword)hook_quit13;
            break;
        case 14:
            hook_list[id].exit = (dword)hook_exit14;
            hook_list[id].quit = (dword)hook_quit14;
            break;
        case 15:
            hook_list[id].exit = (dword)hook_exit15;
            hook_list[id].quit = (dword)hook_quit15;
            break;
        default:
            hook_list[id].exit = (dword)hook_exit16;
            hook_list[id].quit = (dword)hook_quit16;
            break;
    }

    //patch exit
    //the original firwmare code
    exTAP_ApplyPatch3(hook_list[id].exit, (byte *)hook_list[id].exit, &hook_list[id].hook.from[0], hook_list[id].hook.length);
    //a jump back to the firmware                                                   //08xxxxxx j (hook_list[id].hook.addr+hook_list[id].hook.length)
    *(dword *)(hook_list[id].exit + hook_list[id].hook.length + 0x0) = 0x08000000 | (((hook_list[id].hook.addr+hook_list[id].hook.length) & 0x0ffffffc) >> 2);
    *(dword *)(hook_list[id].exit + hook_list[id].hook.length + 0x4) = 0x00000000;  //00000000 nop

    //an rts for patching out functions
    *(dword *)(hook_list[id].quit + 0x0) = 0x03e00008;     //03e00008 jr $ra
    *(dword *)(hook_list[id].quit + 0x4) = 0x00000000;     //00000000 nop
    *(dword *)(hook_list[id].quit + 0x8) = 0x00000000;     //00000000 nop
    *(dword *)(hook_list[id].quit + 0xc) = 0x00000000;     //00000000 nop

    //hook firmware
    *(dword *)((dword)&hook_list[id].to[0]) = 0x08000000 | ((((dword)hook_entry) & 0x0ffffffc) >> 2);   //08xxxxxx j  hook_entry
    *(dword *)((dword)&hook_list[id].to[4]) = 0x24010000 | (((id<<4) + *(dword *)fw_tap_ident) & 0xffff);                          //24010003 li $at, id   //dont use 0
    ret = exTAP_ApplyPatch3(hook_list[id].hook.addr, &hook_list[id].hook.from[0], &hook_list[id].to[0], hook_list[id].hook.length);
    if (ret) {
        return ret;
    }

    hook_list[id].hook.enable = 1;

    //make the id unique to ths tap
    id = (id << 4) + *(dword *)fw_tap_ident;

    return id;
}

int exTAP_RemoveHook(int id)
{
    int ret;

    //undo the uniqueness hack
    id = id >> 4;


    if ((id <1) || (id > MAX_HOOKS)) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), invalid id - %d", __func__, id);
#endif
        return EXTAPERR_OTHER;
    }
    if (hook_list[id].hook.enable == 0) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), hook %d is not enabled", __func__, id);
#endif
        return EXTAPERR_OTHER;
    }

    //unhook firmware
    ret = exTAP_ApplyPatch3(hook_list[id].hook.addr, &hook_list[id].to[0], &hook_list[id].hook.from[0], hook_list[id].hook.length);

    if (ret == 0) hook_list[id].hook.enable = 0;
    return ret;
}

//----------------------------------------------------------------------------
