#include <tap.h>
#include "exTap.h"

//----------------------------------------------------------------------------
int exTAP_TAP_Load(char *filename);
int exTAP_Shutdown(void);
int exTAP_SendMessage(dword param1, dword param2);

//void *fw_add_task_queue = 0;
//void *fw_tap_load = 0;
//
//dword *fw_tap_load_data0 = 0;
////dword *fw_tap_load_data1 = 0;
//dword *fw_tap_load_data2 = 0;
//----------------------------------------------------------------------------
//int init_tap()
//{
//    fw_tap_load = (void *)exTAP_GetFirmwareAddress(fwlist_tap_load);
//
//    fw_tap_load_data0 = (dword *)exTAP_GetFirmwareAddress(fwlist_tap_load_data0);
////    fw_tap_load_data1 = (dword *)exTAP_GetFirmwareAddress(fwlist_tap_load_data1);
//    fw_tap_load_data2 = (dword *)exTAP_GetFirmwareAddress(fwlist_tap_load_data2);
//}
//----------------------------------------------------------------------------
//
// TAP Load function
//
// this function installs a tap
//
int exTAP_TAP_Load(char *filename)
{
    int ret;
    volatile dword tapIndex = 0;
    type_TAPProcess *TAPProcess;

//    if ((fw_tap_load  == 0) || (fw_tap_load_data0 == 0) || (fw_tap_load_data1 == 0) || (fw_tap_load_data2 == 0)) {
    if ((fw_tap_load  == 0) || (fw_tap_load_data0 == 0) || (fw_tap_load_data2 == 0)) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
#endif
        return EXTAPERR_BAD_FIRMWARE;
    }

    //deadbeef claims fw_tap_index can get overwritten - so it does ...
    // store the current TAP index
    tapIndex = *(dword *)fw_tap_ident;

    //this should be the tap's current dir
//    *fw_tap_load_data0 = *fw_tap_load_data1;                                      //"==/ProgramFiles" ???
    TAPProcess = (type_TAPProcess *)(fw_tap_table + ((*(dword *)fw_tap_ident)*32));
    *fw_tap_load_data0 = (dword)TAPProcess->currentDir;

    ret = exTAP_CallFirmware(fw_tap_load, (dword)filename, 0,0,0, 0,0,0,0,0,0,0);

    //now restore the fw current dir
    *fw_tap_load_data0 = *fw_tap_load_data2;

    // restore the TAP index which has been overwritten by fw_tap_load
    *(dword *)fw_tap_ident = tapIndex;

    return ret;     //the tap load address, 0=fail,
}

//----------------------------------------------------------------------------
//
// TAP Shutdown function
//
// this function shuts down the box
//
#define FW_SHUTDOWN_TASK        0xef00          //the shutdown task id

int exTAP_Shutdown(void)
{
    if (fw_add_task_queue == 0) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
#endif
        return EXTAPERR_BAD_FIRMWARE;
    }

    exTAP_CallFirmware((void *)fw_add_task_queue, FW_SHUTDOWN_TASK, 0x0, 0,0, 0,0,0,0,0,0,0);       //task_ef00

    return 0;
}

//----------------------------------------------------------------------------
//
//send the message to all taps
//
int exTAP_SendMessage(dword param1, dword param2)
{
    int i;
    int ret = 0;
    type_TAPProcess *TAPProcess;

    for (i=0; i<16; i++) {
        //dont call ourselves
//        if (i == *fw_tap_ident) {
//        }
//        else {
            TAPProcess = (type_TAPProcess *)(fw_tap_table + (i*32));
            if (TAPProcess->firmwaregp) {
                if (TAPProcess->header) {
                    ret = exTAP_CallTap(i, (void *)(TAPProcess->entryPoints->TAP_EventHandler), (dword)EVT_MESSAGE, (dword)param1, (dword)param2, 0,0,0,0,0,0,0,0);
                    //if ret = 0, don't send to any more taps
                    if (ret == 0) return 0;
                }
            }
//        }
    }
    return ret; //return value from last tap
}

//----------------------------------------------------------------------------
