#include <tap.h>
#include "exTap.h"

//----------------------------------------------------------------------------
int exTAP_GetTwinkle();
int exTAP_SetTwinkle(int enable);

//----------------------------------------------------------------------------
int exTAP_GetTwinkle()
{
    int twinkle;

    if (fw_twinkle == 0) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
#endif
        return EXTAPERR_BAD_FIRMWARE;
    }

    twinkle = (int)*(word *)fw_twinkle;
    return twinkle;
}

int exTAP_SetTwinkle(int enable)
{
    if (fw_twinkle == 0) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
#endif
        return EXTAPERR_BAD_FIRMWARE;
    }

    *(word *)fw_twinkle = enable;
    return EXTAPERR_NONE;
}

//----------------------------------------------------------------------------
